/*
 * File:   main.c
 * Author: Miro
 *
 * Created on Piatok, 2021, oktbra 1, 21:49
 */


#include <xc.h>
#include "mcc_generated_files/mcc.h"

// multiply by ~4,5 minutes
#define TIME_MIN    15
#define TIME_MAX    250

uint16_t lfsr (uint16_t seed);

void main(void) {
    uint8_t pw = 0;
    uint8_t slope = 0; //0-rise, 1-fall
    uint16_t seed;
    uint16_t rnd;
    uint8_t period;
    uint8_t timer = 0;
    uint8_t i;
    SYSTEM_Initialize();
    for(i=0;i<50;i++)
    {
       while(!INTCONbits.TMR0IF);
       INTCONbits.TMR0IF = 0;
    }
    TEST_SetHigh();
    PWM2_LoadDutyValue(0);
    PWM1_LoadDutyValue(0);
    seed = ADC_GetConversion(channel_AN1);
    TEST_SetLow();
    seed|=1;
    lfsr(seed);
    ADCON0 = 0;
    while(1)
    {
        PWM2_LoadDutyValue(0);
        PWM1_LoadDutyValue(0);
        rnd = lfsr(0);
        period = (rnd%((TIME_MAX+1)-TIME_MIN))+TIME_MIN;
        WDTCONbits.SWDTEN = 1;
        while(timer<period)
        {
            PWM1CONbits.PWM1EN = 0;
            PWM2CONbits.PWM2EN = 0;
            SLEEP();
            NOP();
            timer += 1;
        }
        timer = 0;
        WDTCONbits.SWDTEN = 0;
        PWM1CONbits.PWM1EN = 1;
        PWM2CONbits.PWM2EN = 1;
        for(i=0;i<4;i++)
        {
            while(1)
            {
                while(!INTCONbits.TMR0IF);
                INTCONbits.TMR0IF = 0;
                if(rnd&0x0080)
                {
                    PWM1_LoadDutyValue(0);
                    PWM2_LoadDutyValue((uint16_t)pw<<1);
                }
                else
                {
                    if(rnd&0x8201)
                    {
                        PWM1_LoadDutyValue((uint16_t)pw<<1);
                        PWM2_LoadDutyValue((uint16_t)pw<<1);
                    }
                    else
                    {
                        PWM2_LoadDutyValue(0);
                        PWM1_LoadDutyValue((uint16_t)pw<<1);
                    }
                }
                
                if(slope==0)
                {
                    if(pw<120)
                        pw+=1;
                    else
                        pw+=4;
                    if(pw>250)
                    {
                        slope=1;
                        pw = 250;
                    }
                }
                if(slope==1)
                {
                    if(pw>120)
                        pw-=4;
                    else
                        pw-=1;
                    if(pw<5)
                    {
                        slope=0;
                        pw = 0;
                        break;
                    }
                }       
            }
        }
    }
}
//-----------------------------------------------------------------------------
//------------------------------------------------------------------------------
//-----------------------------  
//10-bitovy Fibonacciho LFSR pre generovanie pseudonahodnych hodnot PWM duty cycle
//pri prvom volani funkcie je potrebne zadat pociatocnu nenulovu hodnotu (seed) - funkcia uz teraz vrati pseudonahodne cislo
//pri kazdom dalsom volani treba pre spravnu funkciu zadat do parametra 0
//XOR-ovane su 10-ty a 7-my bit (maximum length - overene)
uint16_t lfsr (uint16_t seed)
{
	static uint16_t sr;
	uint16_t x1,x2,x3;
	
	//testuje ci ide o inicializaciu alebo o generovanie cisla
	//upravuje pripadny seed na 10-bitove cislo
	seed &= 0x03FF;
	if(sr == 0)
	{
		if(seed == 0)
			return 0;
		else
			sr = seed;
	}
	
	x1 = sr & 0x0200;
	x2 = (sr & 0x0040)<<3;
	x3 = x1 ^ x2;
	sr = sr<<1;
	sr = sr & 0x03FF;
	sr = sr | (x3>>9);	

	return sr;
}
